//	 package project;
	/**
	 * This object will have the details of each node( i.e Each character
	 * and operator.
	 * @author Jobby Jacob
	 */
import java.util.*;

public class Node{
	    protected String token;  // The corresponding character
	    protected Node leftChild;  // The left child
	    protected Node rightChild; // The right child
	    protected int column;      // The corresponding column in the truth table
	    protected int priority=0;  // The priority for the operator
	    
	    public Node(String token, int column){
	        this.token=token;
	        this.column=column;
	        this.leftChild=null;
	        this.rightChild=null;
	    }
	    public Node(String token){
	        this.token=token; // Constructor used when a left or right parenthisis is seen
	    }
	    
	    public Node copy()
	    {
	    	Node n = new Node(token);
	    	return n;
	    }
	    
	    protected void setLeftChild(Node n){
	        //this.leftChild.token = "empty";
	    	this.leftChild=n.copy();
	    }
	    
	    protected void setRightchild(Node n){
	        this.rightChild=n.copy();
	    }
	    
	    protected String getToken(){
	        return(this.token);
	    }
	    
	    protected int getColumn(){
	        return(this.column);
	    }
	    
	    protected Node getLeftChild(){
	        return(this.leftChild);
	    }
	    
	    protected Node getRightChild(){
	        return(this.rightChild);
	    }
	    
	    protected void setPriority(int p){
	        this.priority=p;
	    }
	    
	    protected void setToken(String t)
	    {
	    	this.token = t;
	    }
	    protected int getPriority(){
	        return(this.priority);
	    }
	}

