// package project;
/**
 * This object will have the details of each node( i.e Each character
 * and operator.
 * @author Jobby Jacob
 * extensive modifications May 21, 2006
 * @ author Daniel D. Warner
 */
public class Node{
    protected char character;  // The corresponding character
    protected Node leftChild;  // The left child
    protected Node rightChild; // The right child
    protected int column;      // The corresponding column in the truth table
    protected int priority=0;  // The priority for the operator
    public Node(char character, int column){
        this.character=character;
        this.column=column;
        this.leftChild=null;
        this.rightChild=null;
    }
    public Node(char c){
        this.character=c; // Constructor used when a left or right parenthisis is seen
    }
    
    protected void setLeftChild(Node n){
        this.leftChild=n;
    }
    
    protected void setRightchild(Node n){
        this.rightChild=n;
    }
    
    protected char getCharacter(){
        return(this.character);
    }
    
    protected int getColumn(){
        return(this.column);
    }
    
    protected Node getLeftChild(){
        return(this.leftChild);
    }
    
    protected Node getRightChild(){
        return(this.rightChild);
    }
    
    protected void setPriority(int p){
        this.priority=p;
    }
    
    protected int getPriority(){
        return(this.priority);
    }
}


