// package project;
/**
 * The applet which takes the logical expression from the text window
 * and displays the truth table step by step
 *
 * @ author Jobby Jacob
 * extensive modifications May 21, 2006
 * @ author Daniel D. Warner
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.math.*;
import java.io.*;

public class truthTableApplet extends Applet {
    
    protected truthTable t;

    private boolean clear=true;
    private boolean next=false;
    private boolean error=false;
    private int i;
   
    /*The push down buttons*/
    
    protected Button submitButton;
    protected Button nextButton;
    protected Button clearButton;
    
    /* The text window */
    protected TextField tf;
   
    private String input,exp;
    
    
    public truthTableApplet() {
    }


    
    public void init() {
        Font label=new Font("Monospaced", Font.BOLD, 14);
        setLayout(new FlowLayout());
        Label info = new Label("Use '~' for NEGATE, '*' for AND and '+' for OR.");
        Label info2=new Label("Use only lower case letters.");
        info.setFont(label);
        info2.setFont(label);
        info2.setForeground(Color.red);
        info.setForeground(Color.red);
        tf = new TextField("",50);
        submitButton = new Button("Submit");
        nextButton = new Button("Next");
        clearButton=new Button("Clear");
        submitButton.setBackground(Color.cyan);
        submitButton.setForeground(Color.black);
        add(info);
        add(info2);
        add(tf);
        add(submitButton);
        add(nextButton);
        add(clearButton);
        
        
    }


    
    public void paint(Graphics g) {
        if(!clear){
            g.drawString(exp, 5, 140); /* Printing out the entered expression */
            if(error){
                g.setColor(Color.red);
                g.drawString("Invalid expression",5,160); /* Printing out the error message */
                g.setColor(Color.black);
            }else{
                /* Printing out the first row of the table which are characters */
                g.setColor(Color.black); 
                String s="";
                int c=0,n=0,l=0;
                for(int h=0;h<input.length();h++){
                    if(input.charAt(h)=='('){
                        s=s+input.charAt(h);
                    }else if(input.charAt(h)==')'){
                      n++;
                      s=s+input.charAt(h);
                      g.drawString(s,4*(n+l)+5+(c-1)*50, 160);
                      s="";
                            
                        
                    }else{
                        s=s+input.charAt(h);
                        g.drawString(s,5+c*50,160);
                        c++;
                        n=0;
                        l=s.length();
                        s="";
                    }
                }
                g.setColor(Color.black);
                /* Printing out the columns in the order of operations performed */
                for(int j=0;j<i;j++){
                    if((int)t.result[j].character>96&&(int)t.result[j].character<123){
                        g.setColor(Color.blue);
                    }else{
                        g.setColor(Color.black);
                    }
                    if(j==t.count-1){
                        g.setColor(Color.yellow);
                        g.fillRect(t.result[j].column*50, 170, 20, 15*(int)Math.pow(2,t.charCount));
                        g.setColor(Color.red);
                    }
                    for(int k=0;k<(int)Math.pow(2,t.charCount);k++){
                        if(t.table[k][t.result[j].column]==1){
                            g.drawString("T",5+t.result[j].column*50,180+(15*k));
                        }else{
                            g.drawString("F",5+t.result[j].column*50,180+(15*k));
                        }
                    }
                }
            }
        }
    }
    
    
    public boolean action(Event e, Object arg) {
 
        if (e.target == submitButton) {
            input=tf.getText();
            if(input.length()!=0){
                i=0;
                exp="The entered expression is  ";
                exp=exp.concat(input);
                next = true;
                clear=false;
                error=false;
                this.t = new truthTable(input); //Creating an instance of truthtable
                try{
                    t.validityCheck(input); //Checking for the validity of expression
                }catch(IOException er){
                    error=true;
                }
                finally{
                    if(!error){
                        t.buildTable(input);
                        t.treeBuild(t.result,t.count);
                        t.evalTree(t.result[t.count-1]);
                    }
               }
            }
        }else if(e.target==clearButton){
            tf.setText("");  //Clearing of everything
            clear=true;
            next = false;
            error=false;
            i=0;
        }
           
        else if(e.target==nextButton){
            if(next&&!error){
                if(i<t.count){
                    i++;
                }
            } 
        }
        repaint();
        return true;
    }


    public static void main(String args[]) {
        MyWindow w=new MyWindow(450, 450, 50,50);
        Applet a = new truthTableApplet();
        w.add(a);
        a.init();
        w.showWindow();
    }
}